# -*- rpm-spec -*-

Summary: A CIM provider for libvirt
Name: libvirt-cim
Version: 0.5.1
Release: 4%{?dist}
License: LGPLv2+
Group: Development/Libraries
Source: libvirt-cim-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
URL: http://libvirt.org/CIM/
Requires: unzip
Requires: libvirt
Requires: xen
Requires: tog-pegasus
BuildRequires: libcmpiutil >= 0.4
BuildRequires: tog-pegasus-devel
BuildRequires: libvirt-devel >= 0.3.2
BuildRequires: e2fsprogs-devel
BuildRequires: libxml2-devel
BuildRequires: libcmpiutil-devel
BuildRequires: xen-devel
BuildConflicts: sblim-cmpi-devel
Patch0: parse.patch
Patch1: uuidbuflen.patch
Patch2: uuidcompare.patch
Patch3: infostore_trunc.patch
Patch4: vsss_paramname.patch
Patch5: vsss_logic.patch
Patch6: nostate.patch
Patch7: createsnap_override.patch
Patch8: add_shutdown_rsc.patch
Patch9: vsmc_add_remove.patch
Patch10: override_refconf.patch
Patch11: vsmigser_schema.patch
Patch12: mem_parse.patch
Patch13: mig_prof_ver.patch
Patch14: hyp_conn_fail.patch
Patch15: rm_def_virtdev.patch
Patch16: rm_eafp_err.patch
Patch17: sdc_unsup.patch
Patch18: libvirt-cim-0.5.1-vcpu-count.patch
Patch19: libvirt-cim-0.5.1-vcpu-state.patch
Patch20: libvirt-cim-0.5.1-diskpool-data.patch
# limited to the set of arches where libvirt is present
ExclusiveArch: i386 x86_64 ia64

%description
Libvirt-cim is a CMPI CIM provider that implements the DMTF SVPC
virtualization model. The goal is to support most of the features
exported by libvirt itself, enabling management of multiple
platforms with a single provider.

%prep
%setup -q
chmod -f -x src/* libxkutil/* schema/* README doc/* #base_schema/README*
chmod +X src/* libxkutil/* schema/*
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p0
%patch20 -p1

%build
%configure --disable-werror
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
make %{?_smp_mflags}

%install
rm -fr $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install
make DESTDIR=$RPM_BUILD_ROOT install
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/cmpi/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/cmpi/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/libxkutil.so
mkdir -p $RPM_BUILD_ROOT/etc/ld.so.conf.d
echo %{_libdir}/cmpi > $RPM_BUILD_ROOT/etc/ld.so.conf.d/libvirt-cim.conf
mkdir -p $RPM_BUILD_ROOT/etc/libvirt/cim

%clean
rm -fr $RPM_BUILD_ROOT

%pre
%define REGISTRATION %{_datadir}/%{name}/*.registration
%define SCHEMA %{_datadir}/%{name}/*.mof

%define INTEROP_REG %{_datadir}/%{name}/{RegisteredProfile,ElementConformsToProfile,ReferencedProfile}.registration
%define INTEROP_MOF %{_datadir}/%{name}/{ComputerSystem,HostSystem,RegisteredProfile,ElementConformsToProfile,ReferencedProfile}.mof

# _If_ there is already a version of this installed, we must deregister
# the classes we plan to install in post, otherwise we may corrupt
# the pegasus repository.  This is convention in other provider packages
%{_datadir}/%{name}/provider-register.sh -d -t pegasus \
	-n root/virt \
	-r %{REGISTRATION} -m %{SCHEMA} >/dev/null 2>&1 || true

%post
/sbin/ldconfig

%{_datadir}/%{name}/install_base_schema.sh %{_datadir}/%{name}

/etc/init.d/tog-pegasus condrestart

%{_datadir}/%{name}/provider-register.sh -t pegasus \
	-n root/virt \
	-r %{REGISTRATION} -m %{SCHEMA} >/dev/null 2>&1 || true
%{_datadir}/%{name}/provider-register.sh -t pegasus \
	-n root/virt \
	-r %{REGISTRATION} -m %{SCHEMA} >/dev/null 2>&1 || true
%{_datadir}/%{name}/provider-register.sh -t pegasus \
	-n root/interop \
	-r %{INTEROP_REG} -m %{INTEROP_MOF} -v >/dev/null 2>&1 || true

#
# Basically if using a more recent version of libvirt like 0.4.x/0.5.x
# the diskpool.conf is not needed, the check is done only at install time
# though, that won't protect against later libvirt upgrades.
#
virsh -v | grep -q '^0.3' && cp %{_datadir}/%{name}/diskpool.conf /etc/libvirt/ || true

%preun
%{_datadir}/%{name}/provider-register.sh -d -t pegasus \
	-n root/virt \
	-r %{REGISTRATION} -m %{SCHEMA} >/dev/null 2>&1 || true

%postun -p /sbin/ldconfig

%files 
%defattr(-, root, root)
%{_sysconfdir}/libvirt/cim

%doc README COPYING doc/CodingStyle doc/SubmittingPatches
#%doc base_schema/README.DMTF
%doc doc/*.html
%{_libdir}/lib*.so*
# CIM providers are .so modules, thus they belong in the main package
%{_libdir}/cmpi/lib*.so*
%{_datadir}/libvirt-cim/*.sh
%{_datadir}/libvirt-cim/*.mof
%{_datadir}/libvirt-cim/cimv*-interop_mof
%{_datadir}/libvirt-cim/*.registration
%{_datadir}/libvirt-cim/fix_schema.patch
%{_datadir}/libvirt-cim/cimv*-MOFs.zip
%{_sysconfdir}/ld.so.conf.d/libvirt-cim.conf
%{_datadir}/libvirt-cim/diskpool.conf

%changelog
* Fri Nov  7 2008 Daniel Veillard <veillard@redhat.com> - 0.5.1-4.el5
- with an old libvirt we need to install diskpool.conf
- Resolves: rhbz#470276

* Tue Nov  4 2008 Daniel Veillard <veillard@redhat.com> - 0.5.1-3.el5
- couple of patches to add dynamic active vcpu reports
- Resolves: rhbz#469117

* Tue Oct  7 2008 Daniel Veillard <veillard@redhat.com> - 0.5.1-2.el5
- add missing tog-pegasus dependancy
- Resolves: rhbz#465916

* Tue Sep 23 2008 Daniel Veillard <veillard@redhat.com> - 0.5.1-1.el5
- Updated to 0.5.1 upstream release
- added a bunch of extra patches present upstream and in Fedora
- Resolves: rhbz#438555

* Fri Jul  4 2008 Daniel Veillard <veillard@redhat.com> - 0.5-1.el5
- Updated to 0.5 upstream release
- Resolves: rhbz#438555

* Fri Mar 14 2008 Dan Smith <danms@us.ibm.com> - 0.3-4
- Fixed loader config for 64-bit systems
- Added missing root/interop schema install
- Added RegisteredProfile.registration to install

* Fri Mar 07 2008 Dan Smith <danms@us.ibm.com> - 0.3-2
- Added KVM method enablement patch

* Mon Mar 03 2008 Dan Smith <danms@us.ibm.com> - 0.3-1
- Updated to latest upstream source

* Wed Feb 13 2008 Dan Smith <danms@us.ibm.com> - 0.2-1
- Updated to latest upstream source

* Thu Jan 17 2008 Dan Smith <danms@us.ibm.com> - 0.1-8
- Add ld.so.conf.d configuration

* Mon Jan 14 2008 Dan Smith <danms@us.ibm.com> - 0.1-7
- Update to offical upstream release
- Patch source to fix parallel make issue until fixed upstream

* Mon Jan 07 2008 Dan Smith <danms@us.ibm.com> - 0.1-3
- Remove RPATH on provider modules

* Mon Jan 07 2008 Dan Smith <danms@us.ibm.com> - 0.1-2
- Cleaned up Release
- Removed unnecessary Requires
- After install, condrestart pegasus
- Updated to latest source snapshot

* Fri Oct 26 2007 Daniel Veillard <veillard@redhat.com> - 0.1-1
- created
